# 让面试官来告诉你，哪类 iOS 开发更容易被青睐？

![](https://ws1.sinaimg.cn/large/bf676845ly1g22g0mpeo0j232m1zn177.jpg)

在当下这个**金三银四**的时期，我们经常会看到「XXX 的面试准备」、「XXXX 面试心得」、「XXX 面试之路」之类的文章。但是这些都是站在**面试者**的角度出发的文章。总结了各大公司的面试流程，分享面试深度、广度。对于自己面试的表现只能从自身的表现，亦或者是从面试官的微表情中透露出来的一些动作来感知。但是我认为这些不一定准确的，只是自己的主观意识罢了~

所以今天，我们换个角度，我们来问问看**面试官**，在我们的面试过程中，面试官们更青睐于哪类人呢？下面的回答，我期望读者们能类比一下自身，小编自己看完之后，也是深有体会💪💪💪。那么就让我们开始吧~

## 折腾范儿_味精
蚂蚁金服会员技术部面试官，江湖俗称味精，在 Web 方面有很深的了解

1. **探寻机制原理**，不满足于只完成功能需求的。这一点侧面可以证明候选人有解决疑难杂症的优秀潜力，见识过更多优秀的代码，只停留在遇到问题再谷歌百度，最终完成功能需求的，并不是我青睐的。
2. 对于工作有自己的**主动性设计与产出**，并且能体现出**技术深度与成长**的。简单的来说如果有一天老板不给你安排任务了，不给你提明确的需求做 xxx 了，你自己能有什么样的规划思考以及对项目对自己的技术提升，这一点体现主观能动性与发现问题解决问题的潜质。

## 没有故事的卓同学
老司机周报发起人，目前是奇志科技 iOS 团队负责人

我们当下的主要业务是利用无人机采集数据，推动行业作业效率。移动端要处理：无人机的任务控制（按规定的航线、动作采集数据）、无人机的数据处理（拍到的图片、视频）。和服务器的通讯是很重要的一环，也有类似直播推无人机的图传视频流的场景。我们的产品 UI 的比重少，没有那么多页面，更多时候是针对一个需求，提出一个合理的技术方案，然后保证这个方案高质量的实现。

按照前面提到的要求，我们会要求移动端的开发人员一定要有良好的**计算机基础知识**。不是计算机专业，培训班了几个月 UI 写的溜的就完全不合适。在大的业务型公司中写了几年 UI 的也不匹配。我们要解决一个需求时，要考虑无人机硬件上的能力、飞控的能力、无人机通信上的限制、数据到 native 层后如何处理。如果计算机基础知识掌握的好，遇到我们业务上的难题就能解决的越好。所以背后还隐含了对新技术的探索、理解能力。

因为看中**新技术的探索**、**学习能力**，所以喜欢**折腾**其他端技术的程序员我们也很偏爱。为了保证移动团队可以有效的沟通，会尽量 iOS 和 Android 大的架构上保持一致。两端也都深度使用了 Rx。我们面向不同行业应用的 UI 是使用类似 RN 技术实现的，UI 构建代码是 js。因此 iOS 团队提供了接触安卓、前端的机会。如果一个程序员有兴趣，在我们这边就可以实现一个功能，三端代码一个人写。

## Tom
广州头条 EE 团队初创成员，资深面试官

1. **沟通能力**第一位，其次考察学习能力和知识深度，特别喜欢能够举一反三的候选人。
2. 有强烈的**学习自驱力**会加分，另外能够经常了解项目上下游事情的候选人也会加分。
3. 软素质部分，比较看中是否能够在相对苛刻的外部压力下找到解决方案，譬如对一个随机出现的 BUG 揪住不放，用了较多的个人业余时间赶上当前版本周期解决。

> 广州头条急招各种岗位，求简历ing，小T微信：tomtan，切磋技术和聊情怀都可以喔~~~~

## Parsifal
老司机周报负责人，微医生 iOS 团队负责人

对不同职位要求倾向性也会有一定区别。若招的是初中级或者实习生，我想基本功和学习能力是会占到比较大的比重的。而相对若招的是更深层次的人才，则对于技术深度和广度都会有更大的要求。在硬能力差不多的前提下，我谈谈在面试过程中会让我感觉眼前一亮有加分的一些表现吧。

1. 认真听题目，理解考察目的，针对性和有**条理性**地梳理思路而后开始回答。一类应聘者在面试过程中，会试图打断面试官提问做抢答，这是极不好的一个习惯。不仅会让面试官觉得你会较急躁，且不太礼貌，而且往往回答得并不是面试官真正想要问的。另一类应聘者则是回答问题并没有一个很清晰的思路，自顾自地侃侃而谈了很多，最后越来越偏离主题，反而是起到反效果。相应地，如果你能够分点有层次地答题，不仅自己不会答漏，也能让面试官轻松得 get 到你的掌握程度。
2. **气质**与团队的**气质**能够有较大地契合。每个团队都会有自己的**气质**，这会在平常工作中体现的很明显。如果你应聘的团队是较激进有活力的，对各类新技术都很热衷尝试和沉淀，而你属于较沉稳保守的，那到团队内久了就会显得格格不入。
3. 喜欢自己从事的工作，关注业内的技术和生态发展，对近期圈子里能够有一定的了解。这一点很可能会映射出你是否会持续成长。在 WWDC 期间，我往往会聊一些相关的作为破冰话题。
4. 定期有**计划**地梳理自己的知识体系。如果你有这个习惯，可以提前传到 GitHub 等地方，并在简历上体现。
5. 保持**谦逊**，不要浮夸和自以为是。遇到过太多对自己迷之自信的应聘者，但往往技术是越到深处越觉得学无止境的。

## 享耳先森
丁香园 iOS 团队负责人

1. iOS 及软件工程上有足够的硬实力。
2. 软实力方面，比较考察 **学习能力**、**主动性**，我们比较喜欢做事能够做到实时反馈的人，而不是需要其他人去推动。
3. 心态方面，我们会要求候选人 **心智成熟、心态开放**，并不太喜欢甩锅的行为，能够主动承担责任。

## Jason
即刻 iOS 团队负责人

除了专业技能、算法基本功符合岗位要求之外，我们还有一个 iOS 面试原则，不论职级高低都需要满足：

1. 真实直接，是什么说什么，绕弯子的不要。
2. 心态一定要开放，有旺盛的好奇心和想象力，不管自己 Level 是高是低，都愿意拥抱新的更好的技术和思想，**少年心气**。
3. **沟通协作**能力一定要强，只喜欢单打独斗的不要。
4. 遇到问题的时候，老从其他人身上找原因的不要。

我们认为公司氛围与个人能力都很重要。只要文化足够好，就算刚入职的时候经验不足，将来成长空间和速度也是非常可观的。

## 总结

OK~我们看完了这么多大佬的话语之后是不是都有一些自己的感触呢？小编我自己作为面试官的次数并不多，就不高谈阔论了。简单几个词，总结一下本篇的言论。（如果每个单题都是20分，你给自己打几分呢？评论区可以留言哦！打💯或者超过💯的童鞋，🙄让我们膜拜一下。）

1. 探索精神
2. 心智成熟、心态开放
3. 沟通协作能力
4. 主动性
5. 强逻辑思维

最后，祝大家看完本文后都有所收获，面试顺利~😊😊😊

## 内推

老司机周报团队联合知识小集和 SwiftGG 翻译组收录了一份靠谱的内推职位。

如果你想**找工作**，点这里：https://www.yuque.com/iosalliance/article/bhutav

如果你想**招人**，点这里：https://www.yuque.com/iosalliance/article/ycyhf3

当然，也欢迎你关注我们每一期的周报，我们会在每期周报底部及时更新编辑内推岗位。