# 老司机 iOS 周报 #8 | 2018-02-26

![ios-weekly](../assets/ios-weekly.png)

新的一年，欢迎第十位编辑 [@Parsifal](https://weibo.com/parsifalchang) 的加入。

## 新闻

### [App Store 描述截图从 5 张增加到 10 张](http://app.techweb.com.cn/ios/2018-02-23/2639654.shtml)

苹果再次对 App Store 更新了上架规则，新的规则宣布，开发者对于其开发的 App，在截图介绍部分可以添加 10 张屏幕截图，而之前是 5 张。

### [四月起，所有提交审核的 APP 都要基于 iOS 11 的 SDK 开发](https://developer.apple.com/news/?id=02152018a)

苹果发出最新通知，从 2018 年 4 月开始，所有提交审核的 APP 都要基于 iOS 11 的 SDK 开发，且支持 iPhoneX 的 [Super Retina 显示屏](https://support.apple.com/en-om/HT208191)。

这也意味着，开发者至少需要使用 Xcode 9 来开发 App ，并确保他们的 APP，在 iPhoneX 上根据安全区域进行了适配。

## 文章

### 🌟 [探索 iOS 内存分配](https://juejin.im/post/5a5e13c45188257327399e19)

介绍了 iOS（OS X）系统中 VM 的相关原理，以及如何使用 VM Track 模板来分析 VM Regions，通过深入了解 iOS 的内存分配，可以有针对性的对内存进行优化。

### 🌟 [移动场景下通信协议 FlatBuffers、ProtocolBuffers、MessagePack 选优](https://www.jianshu.com/p/987c4d16c48b)

JSON 有可读性高、易于使用的优点。但是也有解析费时、解析内存耗费高、及数据量大的缺点。除了 JSON，现在主流的还有 MessagePack、FlatBuffer、ProtocolBuffers 通信协议。文章综合不同场景对比了这几种通信协议的优劣。

### [Just Controllers](http://khanlou.com/2018/02/just-controllers)

iOS 上的 MVC 模式最后会导致 VC 中有大量代码在业界已经达成了共识。优化的一种方式是把 VC 中的代码拆分到 child view controller。实践中你会发现 child view controller 的使用起来并不像 UIView 一样简单，要注意它和 parent view controller 的生命周期控制。View controller 中的 view 使用起来和一个单纯的 UIView 实例也有不同。有的场景自定义一个 controller 类包含 UIView 也许会是一个更好的主意。

### [UIVisualEffectView Tutorial: Getting Started](https://www.raywenderlich.com/178486/uivisualeffectview-tutorial-getting-started)

利用 UIKit 中提供的 UIVisualEffectView 来实现常见的模糊背景的效果简单又好用。文章介绍了模糊的算法原理和 UIVisualEffectView 的使用方式。

### [Unit testing asynchronous Swift code](https://www.swiftbysundell.com/posts/unit-testing-asynchronous-swift-code)

介绍了单元测试中处理异步代码的几个小技巧：通过设置 `XCTestExpectation` 的 `inverted` 属性来验证任务是否完成；将异步闭包添加到同步线程中，接着在同步线程中执行一个空的闭包来判断异步操作是否执行完成；在代码中通过 mock 将异步的操作封装为同步的操作方式来避免处理异步的情况。

### 🚧 [iOS Developer Roadmap](https://medium.com/ios-os-x-development/ios-developer-roadmap-c9a24f413457)

国外开发者维护的 iOS 开发技能导图，作者将 iOS 开发中所涉及到的技能总结为一个个 topic，并提供对应 topic 的学习资源。无论你是还未入门的小白，还是想继续提升的开发者，亦或是正在准备面试的求职者，都可以利用这份图谱进行知识学习和梳理。

### [iOS IP 直连原理剖析](https://juejin.im/post/5a81bbd66fb9a0634c266fe1)

移动互联网的网络状况十分复杂，三大运营商、3G、4G、Wi-Fi、地点等任何一个状态的改变都会导致网络状况的变化，IP 直连可以跨过运营商 LocalDNS 服务器解析过程，从而达到降低延迟、避免劫持的效果。本文对 iOS IP 直连原理进行了剖析，高度概括，通俗易懂，值得一看。

### [iOS Code Signing Tutorial Series](https://medium.com/xcblog/ios-code-signing-tutorial-series-814b22eba507)

由 Shashikant Jagtap 发布的 iOS Code Signing 相关系列博客，总共五篇。众所周知，iOS Code Signing 对于大部分 iOS 开发者来说，一直都是最神秘的存在，尽管有所谓的官方文档。显然作者也发现了这个问题，所以他采用了亲身实践的方式，力求更简单的为读者解读 iOS Code Signing 的一些细节，小编大体看了下，确实通俗易懂很多。（PS：有在做技术文章翻译的童鞋可以考虑把这个系列翻译成中文，造福更多开发者～）

### [我是怎么慢慢变懒的(2) : Jenkins 全自动化](http://answerhuang.duapp.com/index.php/2018/02/15/jenkins-2/)

作者根据自己的实际项目经验，写了一篇总结。大概讲了「我搭建了一个怎么样的 Jenkins 环境」以及在搭建过程中遇到了哪些问题。

## 工具

### [Snipaste for Mac 公测版推出](https://zh.snipaste.com/index.html)

具体介绍可以看少数派的文章：[Snipaste for Mac 公测版推出，改变你在 Mac 上的截图体验](https://zhuanlan.zhihu.com/p/31898041)。

## 代码

### [ZHStatusVolume](https://github.com/lacklock/ZHStatusVolume)

设置音量时隐藏系统的 hud，将音量变化展示在状态栏上。用 OC 写的，兼容 Swift，刚刚发布第一个版本，如果使用中有问题欢迎联系我[@没故事的卓同学](https://weibo.com/1926303682/profile)。

### [ReactiveLists](https://github.com/plangrid/ReactiveLists)

ReactiveLists 基于 [React](https://reactjs.org/) 编程思想，封装 UITableView 和 UICollectionView 的 API，使用该 API 可以编写 [无状态函数](https://facebook.github.io/react/docs/reusable-components.html#stateless-functions) 来生成列表页面。作者认为，在向 UIKit 组件提供数据上，这些无状态函数相比 **DataSource**，**Delegate** 更易于阅读和迭代，而且还易于测试。

作者关于 ReactiveLists 的介绍：[Open Sourcing ReactiveLists for iOS](https://medium.com/plangrid-technology/open-sourcing-reactivelists-for-ios-3abdf41b770a)

### [Uber 的 App 开发架构 RIBs](https://github.com/uber/RIBs)

Uber 的跨平台开发框架 RIBs，架构名由 `Router`, `Interactor` 和 `Builder` 的首字母组合而成，表示了该架构的构成。优势如下：

- 在 iOS 和 Android 间共享同一套架构；
- 可测性和隔离性，便于进行单元测试同时各个独立的 RIB 类间高度解耦；
- 提供代码生成、内存泄漏检测、静态分析和运行时集成等一系列开发工具；
- 一种可伸缩的架构，已被证明可适用于几千人基于统一代码库开发的场景。

一种适合响应式编程和大项目的架构，对架构有兴趣的同学一定不要错过。

### [SwifterSwift](https://github.com/SwifterSwift/SwifterSwift)

SwifterSwift 是一个用 Swift 编写的 Extension 的集合，涵盖了开发过程中大部分会用到的方法和函数，是一个不错的工具库。同时 SwifterSwift 大概有 SwiftStdlib Extensions、Foundation Extensions、UIKit Extensions、AppKit Extensions、CoreGraphics Extensions、CoreLocation Extensions、Misc. Extensions 等一系列分类。

## 音视频

### 🚧 🌟 [Swift’s Reflective Underpinnings](https://www.skilled.io/u/swiftsummit/swift-s-reflective-underpinnings-joe-groff)

Swift 核心开发团队成员在 Swift Summit 上的演讲视频。介绍了 Swift 的动态能力的构建基础，提及了未来 Swift 版本中可能引入的动态特性。其实在 Swift 中已经有一些反射的能力，每个类型在内部都有 metadata ，可以查到这个类型的字段、方法，只是没有暴露出来。强烈推荐 Swift 爱好者观看，干货很多。

另外 Swift Summit 的其他视频也都分享在了 [Skilled](https://www.skilled.io) 网站上，大家可以关注一下。

## 本期编辑

[@没故事的卓同学](https://weibo.com/1926303682/profile)，[@mmoaay](https://weibo.com/u/1302422271)，[@EyreFree](https://weibo.com/eyrefree777)，[@Damonwong](https://weibo.com/damonone)，[@张嘉夫](https://weibo.com/2949394297)，[@AidenRao](https://weibo.com/AidenRao)，[@Parsifal](https://weibo.com/parsifalchang)

## 说明

🚧 表示需翻墙，🌟 表示店长推荐


