# 老司机 iOS 周报 #274 | 2024-01-08

![ios-weekly](https://github.com/SwiftOldDriver/iOS-Weekly/blob/master/assets/weekly-header/274.jpg?raw=true)
老司机 iOS 周报，只为你呈现有价值的信息。

你也可以为这个项目出一份力，如果发现有价值的信息、文章、工具等可以到 [Issues](https://github.com/SwiftOldDriver/iOS-Weekly/issues) 里提给我们，我们会尽快处理。记得写上推荐的理由哦。有建议和意见也欢迎到 [Issues](https://github.com/SwiftOldDriver/iOS-Weekly/issues) 提出。

## 新手推荐

### 🐎 [The Art of the Corner Radius](https://david.y4ng.fr/the-art-of-the-corner-radius/)

[@Barney](https://github.com/BarneyZhaoooo)：本篇文章简单介绍了 swiftUI 中 **Corner Radius** 的基础使用，浅显易懂，图文并茂，只需 3 分钟就可以领略“圆角”的艺术。

## 文章

### 🌟 🐢 [微信业务开发方法与实践](https://mp.weixin.qq.com/s/we4LCGAwDC6bS7rQNztWMQ)

[@xuyafei86](https://github.com/xiaofei86)：在当前竞争激烈的商业环境中，深刻理解业务流程对于开发复杂软件系统至关重要。微信团队万字长文带你拔开迷雾，直达本质，深入理解业务是什么，以及如何挖掘业务价值。

本文详细阐释了业务建模的核心概念和方法，并通过支付业务的具体案例进行演示。你将从文中学到如何理解构建的业务系统背后所服务的目标组织，深入其业务流程，找出改进机会。感兴趣的同学可以阅读原文了解。

### [尾调用以及如何规避](https://r3zpy9khqv.feishu.cn/docs/doccnCwMGwhIDmMi4miM7VfHqpe)

[@老峰](https://github.com/gesantung)：尾调用（Tail Call）是函数式编程的一个重要概念，本文介绍它的基本概念以及通过使用 OS_NOT_TAIL_CALLED 规避尾调用的代码优化方式。 

### [浏览器内核创新技术演进及实践 - U4 5.0](https://mp.weixin.qq.com/s/5xIJIN2nUBN2h6McYFg2FQ) 

[@莲叔](https://github.com/aaaron7)：U4 是 UC 基于 Chromium 内核二次开发的浏览器引擎，在阿里内部被广泛的使用。本篇文章介绍了在介绍 U4 的 5.0 新版本特性的同时，也科普了很多浏览器内核相关的技术，比如性能提升的关键模块：渲染引擎与 JS 引擎。移动端目前越来越多的业务通过 H5 来实现，作为客户端的同学多了解一些浏览器引擎的技术对于协助前端做出更优化的体验是很有帮助的。推荐阅读。

### [哥伦布即时设计平台 ChatGPT 落地实践](https://mp.weixin.qq.com/s/5BuX1m_GDHQzuW_Kj2siOw)

[@水水](https://www.xuyanlan.com/)：本文介绍了 ChatGPT 在哥伦布即时设计平台应用以及实现原理，通过设计 ChatGPT 交互 DSL、Prompt 与 Function 实现 Ai 智能交互、提高平台搭建效率。即让 AI 通过 DSL 了解即时设计能力，同时输出 DSL 解析执行，设计平台具备以下能力：
1.画布编辑能力：提供了丰富的画布编辑功能，包括添加、删除、复制、调整层级等操作，可以灵活地编辑页面的结构和布局。
2.样式配置能力：支持对页面元素的样式进行配置，包括字体、颜色、大小、边框等，可以根据需求进行自定义的样式设置。
3.数据接口配置能力：支持与数据接口的绑定，可以通过配置数据接口来实现页面内容的动态展示，提高页面的灵活性和可扩展性。
4.交互事件配置能力：支持对页面元素的交互事件进行配置，包括点击、滑动、弹窗等，可以实现页面的交互效果，提升用户体验。
5.预览和下载能力：提供了在线预览和下载代码的功能，可以实时查看页面效果，并将设计的页面代码下载到本地进行进一步开发和调试。

## 工具

### [Unxippity](https://trycombine.com/posts/an-app-experiment-about-unxipping-xcode-goes-to-github/)

[@Smallfly](https://github.com/iostalks)：这是一款 [unxip](https://github.com/saagarjha/unxip) 的可视化开源工具，用于加速下载和解压 Xcode。 

## 代码

### [swift-retry](https://github.com/fumoboy007/swift-retry?tab=readme-ov-file)

[@AidenRao](https://weibo.com/AidenRao)：该项目是一个 Swift 语言的重试库，旨在提供合理的默认设置和强大的灵活性。

- 合理的默认设置：默认选择[指数退避](https://en.wikipedia.org/wiki/Exponential_backoff)算法，适用于大部分场景，避免对资源进行 DDoS。
- 强大的灵活性：该库提供了多个自定义选项以适应不同的使用场景，包括自定义关闭、重试配置、退避算法选择以及时钟替换等。

## 内推

重新开始更新「iOS 靠谱内推专题」，整理了最近明确在招人的岗位，供大家参考

具体信息请移步：https://www.yuque.com/iosalliance/article/bhutav 进行查看（如有招聘需求请联系 iTDriverr）

## 关注我们

我们是「老司机技术周报」，一个持续追求精品 iOS 内容的技术公众号，欢迎关注。

**关注有礼，关注【老司机技术周报】，回复「2023」，领取 2023 及往年内参**

![](https://github.com/SwiftOldDriver/iOS-Weekly/blob/master/assets/qrcode_for_wechat.jpg?raw=true)

同时也支持了 RSS 订阅：https://github.com/SwiftOldDriver/iOS-Weekly/releases.atom 。

## 说明

🚧 表示需某工具，🌟 表示编辑推荐

预计阅读时间：🐎 很快就能读完（1 - 10 mins）；🐕 中等 （10 - 20 mins）；🐢 慢（20+ mins）
